'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = getNodes;

function _typeof(obj) { return obj && typeof Symbol !== "undefined" && obj.constructor === Symbol ? "symbol" : typeof obj; }

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

function recursive(ast, visited) {
  var nodes = [];

  if (ast && ast.type && !visited.has(ast)) {
    visited.add(ast);
    nodes.push(ast);
  }

  if (Array.isArray(ast)) {
    return nodes.concat.apply(nodes, _toConsumableArray(ast.map(function (node) {
      return recursive(node, visited);
    })));
  } else if (ast && (typeof ast === 'undefined' ? 'undefined' : _typeof(ast)) === 'object') {
    return nodes.concat.apply(nodes, _toConsumableArray(Object.keys(ast).filter(function (key) {
      return key !== 'tokens' && key !== 'comments';
    }).map(function (key) {
      return recursive(ast[key], visited);
    })));
  }

  return nodes;
}

function getNodes(ast) {
  var visited = new WeakSet();
  var nodes = recursive(ast, visited);
  return nodes;
}
module.exports = exports['default'];