'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = output;
function replacer(key, value) {
  if (value instanceof Error) {
    return value.toString();
  }

  return value;
}

function noUnused(result) {
  return result.dependencies.length === 0 && result.devDependencies.length === 0;
}

function prettify(caption, deps) {
  var list = deps.map(function (dep) {
    return '* ' + dep;
  });
  return list.length ? [caption].concat(list) : [];
}

function output(result, log, json) {
  return new Promise(function (resolve) {
    if (json) {
      log(JSON.stringify(result, replacer));
    } else if (noUnused(result)) {
      log('No unused dependencies');
    } else {
      var deps = prettify('Unused Dependencies', result.dependencies);
      var devDeps = prettify('\nUnused devDependencies', result.devDependencies);
      var content = deps.concat(devDeps).join('\n');

      log(content);
    }

    resolve(result);
  });
}
module.exports = exports['default'];